/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3930_CDPSTPO.SQL

Descrio:
Calcula periodicidade de produo para dias do ms.

P_CDFILIAL     - Cdigo da Filial.
P_CDPERIPRODU  - Cdigo da Periodicidade de Produo.
P_DTINICIAL    - Data inicial a ser gerado o clculo.
P_IDDIANUTIL   - Indicador de utilizao de dia no til para produo.
P_DTPROCESSA   - Data de Processamento da Filial.

PARA DEBUGAR
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
08/09/2004 - Fabrcio Marcelo da Silva
*/

CREATE OR REPLACE PROCEDURE PERIPRODUCAO_MENSAL
  (P_CDFILIAL     IN VARCHAR2,
   P_CDPERIPRODU  IN VARCHAR2,
   P_DTINICIAL    IN DATE,
   P_IDDIANUTIL   IN VARCHAR2,
   P_DTPROCESSA   IN DATE) IS

   V_CONTAUXI    NUMBER;
   V_DIPRODUCAO  VARCHAR2(2);
   V_DTDIAPRODU  DATE;

/*-------- CURSOR QUE CONTEM TODOS OS DIAS DE ENTREGA DE DETERMINADA PERIODICIDADE ------*/
   CURSOR C_DIAS_PRODU IS
      SELECT
         DIPRODUCAO
      FROM
         DIASPRODUCAO
      WHERE
         CDPERIPRODU = P_CDPERIPRODU
      ORDER BY
         DIPRODUCAO;
BEGIN
   OPEN C_DIAS_PRODU;
   LOOP
      FETCH C_DIAS_PRODU
      INTO V_DIPRODUCAO;
      EXIT WHEN C_DIAS_PRODU%NOTFOUND;

      V_DTDIAPRODU := (P_DTINICIAL - 1) + V_DIPRODUCAO;
      IF V_DTDIAPRODU > LAST_DAY(P_DTINICIAL) THEN
         V_DTDIAPRODU := LAST_DAY(P_DTINICIAL);
      END IF;

      IF V_DTDIAPRODU >= P_DTPROCESSA THEN

         SELECT
            COUNT(*) INTO V_CONTAUXI
         FROM
            FERICOMP
         WHERE
            CDFILIAL   = P_CDFILIAL    AND
            DTFERICOMP = V_DTDIAPRODU;


         IF TO_CHAR(V_DTDIAPRODU,'DD') >= V_DIPRODUCAO THEN
            IF ((P_IDDIANUTIL = 'S') AND (V_CONTAUXI = 0)) OR
               (P_IDDIANUTIL = 'N')                        THEN
               /*- INCLUI A DATA DE PRODUCAO CALCULADA NO CALENDARIO DE PRODUCAO -*/
               INSERT INTO CALEPRODUCAO
                  (CDFILIAL,
                   CDPERIPRODU,
                   DTPRODUCAO)
               VALUES
                  (P_CDFILIAL,
                   P_CDPERIPRODU,
                   V_DTDIAPRODU);
               COMMIT;
            END IF;
         END IF;
       END IF;
   END LOOP;
   CLOSE C_DIAS_PRODU;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('PERIPRODUCAO_MENSAL','4.07.039'); END;
/

